Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/expressionbuilder/formatters/$Constant.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/expressionbuilder/formatters/$Constant.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/expressionbuilder/formatters/$Constant.java	(revision 46050)
@@ -0,0 +1,90 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2020 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.fmap.dal.store.jdbc2.spi.expressionbuilder.formatters;
+
+import java.util.Objects;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
+import org.gvsig.expressionevaluator.ExpressionUtils;
+import org.gvsig.expressionevaluator.Formatter;
+import org.gvsig.expressionevaluator.SymbolTable;
+import org.gvsig.fmap.dal.SQLBuilder;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_SYMBOLTABLE;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_$CONSTANT;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class $Constant implements Formatter<Value> {
+    
+    private final SQLBuilder sqlbuilder;
+    private final Formatter<Value> formatter;
+    
+    public $Constant(SQLBuilder sqlbuilder, Formatter<Value> formatter) {
+        this.sqlbuilder = sqlbuilder;
+        this.formatter = formatter;
+    }
+    
+    @Override
+    public boolean canApply(ExpressionBuilder.Value value) {
+        if (value instanceof ExpressionBuilder.Function) { 
+            return StringUtils.equalsIgnoreCase(FUNCTION_$CONSTANT, ((Function) value).name());
+        }
+        return false;
+    }
+
+    @Override
+    public String format(Value value) {
+        return resolve(this.sqlbuilder.expression(), this.formatter, value);
+    }
+    
+    public static boolean isConstant(Value value) {
+        if( value instanceof ExpressionBuilder.Constant) {
+            return true;
+        } 
+        return value instanceof ExpressionBuilder.Function && 
+               StringUtils.equalsIgnoreCase(((ExpressionBuilder.Function)value).name(),FUNCTION_$CONSTANT);
+    }
+    
+    public static String resolve(Value value) {
+        ExpressionBuilder builder = ExpressionUtils.createExpressionBuilder();
+        return resolve(builder, null, value);
+    }
+    
+    public static String resolve(ExpressionBuilder builder, Formatter<Value> formatter, Value value) {
+        if( value instanceof ExpressionBuilder.Constant) {
+            Object x = ((ExpressionBuilder.Constant)value).value();
+            return builder.constant(x).toString(formatter);
+        } else if( value instanceof ExpressionBuilder.Function && 
+                StringUtils.equalsIgnoreCase(((ExpressionBuilder.Function)value).name(),FUNCTION_$CONSTANT) ) {
+            SymbolTable symbolTable = (SymbolTable) value.getProperty(PROP_SYMBOLTABLE);
+            Object x = ExpressionUtils.evaluate(symbolTable, value.toString());
+            return builder.constant(x).toString(formatter);
+        } 
+        throw new RuntimeException("Expected constant value or $$CONSTANT function ("+Objects.toString(value)+").");
+    }
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/expressionbuilder/formatters/ComputedAttribute.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/expressionbuilder/formatters/ComputedAttribute.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/expressionbuilder/formatters/ComputedAttribute.java	(revision 46050)
@@ -23,19 +23,23 @@
  */
 package org.gvsig.fmap.dal.store.jdbc2.spi.expressionbuilder.formatters;
 
+import org.gvsig.expressionevaluator.Code;
 import org.gvsig.expressionevaluator.Expression;
 import org.gvsig.expressionevaluator.ExpressionBuilder;
 import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
 import org.gvsig.expressionevaluator.Formatter;
+import org.gvsig.expressionevaluator.GeometryExpressionBuilder;
 import org.gvsig.fmap.dal.SQLBuilder;
 import org.gvsig.fmap.dal.expressionevaluator.FeatureAttributeEmulatorExpression;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureAttributeEmulator;
+import org.gvsig.fmap.dal.feature.FeatureQuery;
 import org.gvsig.fmap.dal.feature.FeatureType;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
 import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_FEATURE_TYPE;
 import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_JDBCHELPER;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_QUERY;
 
 /**
  *
@@ -64,9 +68,15 @@
             }
             ExpressionBuilder.Variable variable = (ExpressionBuilder.Variable) value;
             FeatureAttributeDescriptor attr = featureType.getAttributeDescriptor(variable.name());
-            if( attr==null || !attr.isComputed() ) {
+            if (attr == null) {
+                FeatureQuery query = (FeatureQuery) value.getProperty(PROP_QUERY);
+                attr = query.getExtraColumn().get(variable.name());
+            }
+
+            if (attr == null || !attr.isComputed()) {
                 return false;
             }
+            
             FeatureAttributeEmulator emulator = attr.getFeatureAttributeEmulator();
             if( !(emulator instanceof FeatureAttributeEmulatorExpression) ) {
                 return false;
@@ -82,9 +92,16 @@
         FeatureType featureType = (FeatureType) value.getProperty(PROP_FEATURE_TYPE);
         ExpressionBuilder.Variable variable = (ExpressionBuilder.Variable) value;
         FeatureAttributeDescriptor attr = featureType.getAttributeDescriptor(variable.name());
+        if (attr == null) {
+            FeatureQuery query = (FeatureQuery) value.getProperty(PROP_QUERY);
+            attr = query.getExtraColumn().get(variable.name());
+        }
         FeatureAttributeEmulator emulator = attr.getFeatureAttributeEmulator();
         Expression expr = ((FeatureAttributeEmulatorExpression)emulator).getExpression();
-        return "("+ this.formatter.format(expr.getCode().toValue(this.sqlbuilder.expression()))+")";
+        Code code = expr.getCode();
+        GeometryExpressionBuilder builder = this.sqlbuilder.expression();
+        Value valueExpr = code.toValue(builder);
+        return "("+ this.formatter.format(valueExpr)+")";
     }
     
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/expressionbuilder/formatters/$Identifier.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/expressionbuilder/formatters/$Identifier.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/expressionbuilder/formatters/$Identifier.java	(revision 46050)
@@ -0,0 +1,68 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2020 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.fmap.dal.store.jdbc2.spi.expressionbuilder.formatters;
+
+import java.util.Objects;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
+import org.gvsig.expressionevaluator.ExpressionUtils;
+import org.gvsig.expressionevaluator.Formatter;
+import org.gvsig.expressionevaluator.SymbolTable;
+import org.gvsig.fmap.dal.SQLBuilder;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_SYMBOLTABLE;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_$IDENTIFIER;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class $Identifier implements Formatter<Value> {
+    
+    private final SQLBuilder sqlbuilder;
+    private final Formatter<Value> formatter;
+    
+    public $Identifier(SQLBuilder sqlbuilder, Formatter<Value> formatter) {
+        this.sqlbuilder = sqlbuilder;
+        this.formatter = formatter;
+    }
+    
+    @Override
+    public boolean canApply(ExpressionBuilder.Value value) {
+        if (value instanceof ExpressionBuilder.Function) { 
+            return StringUtils.equalsIgnoreCase(FUNCTION_$IDENTIFIER, ((Function) value).name());
+        }
+        return false;
+    }
+
+    @Override
+    public String format(Value value) {
+        SymbolTable symbolTable = (SymbolTable) value.getProperty(PROP_SYMBOLTABLE);
+        Value p1 = ((ExpressionBuilder.Function)value).parameters().get(0);
+        Object x = ExpressionUtils.evaluate(symbolTable, p1.toString());
+        return this.sqlbuilder.expression().variable(Objects.toString(x, "")).toString(this.formatter);
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCHelperBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCHelperBase.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCHelperBase.java	(revision 46050)
@@ -39,8 +39,6 @@
 import org.gvsig.expressionevaluator.Code;
 import org.gvsig.expressionevaluator.Expression;
 import org.gvsig.expressionevaluator.ExpressionBuilder;
-import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_$$CONSTANT;
-import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_$$IDENTIFIER;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
 import org.gvsig.expressionevaluator.Function;
@@ -96,6 +94,8 @@
 import org.gvsig.tools.visitor.Visitor;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_$CONSTANT;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_$IDENTIFIER;
 
 @SuppressWarnings("UseSpecificCatch")
 public class JDBCHelperBase extends AbstractDisposable implements ResourceConsumer, JDBCHelper {
@@ -336,8 +336,8 @@
                 public boolean test(FilteredVisitable code0) {
                     if (code0 instanceof Code.Callable) {
                         String name = ((Code.Callable) code0).name();
-                        return StringUtils.equalsIgnoreCase(name, FUNCTION_$$CONSTANT)
-                                || StringUtils.equalsIgnoreCase(name, FUNCTION_$$IDENTIFIER);
+                        return StringUtils.equalsIgnoreCase(name, FUNCTION_$CONSTANT)
+                                || StringUtils.equalsIgnoreCase(name, FUNCTION_$IDENTIFIER);
                     }
                     return false;
                 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/H2SpatialFormatter.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/H2SpatialFormatter.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/H2SpatialFormatter.java	(revision 46050)
@@ -5,8 +5,8 @@
 import org.gvsig.expressionevaluator.Formatter;
 import org.gvsig.fmap.dal.DALLocator;
 import org.gvsig.fmap.dal.SQLBuilder;
-import org.gvsig.fmap.dal.store.jdbc2.spi.expressionbuilder.formatters.$$Constant;
-import org.gvsig.fmap.dal.store.jdbc2.spi.expressionbuilder.formatters.$$Identifier;
+import org.gvsig.fmap.dal.store.jdbc2.spi.expressionbuilder.formatters.$Constant;
+import org.gvsig.fmap.dal.store.jdbc2.spi.expressionbuilder.formatters.$Identifier;
 import org.gvsig.fmap.dal.store.jdbc2.spi.expressionbuilder.formatters.ComputedAttribute;
 
 /**
@@ -37,8 +37,8 @@
             new ST_AsBinary(this.builder, this),
             new Exists(this.builder, this),
             new Getattr(this.builder, this),
-            new $$Constant(this.builder, this),
-            new $$Identifier(this.builder, this),
+            new $Constant(this.builder, this),
+            new $Identifier(this.builder, this),
             new ComputedAttribute(this.builder, this),
             DALLocator.getDataManager().createDALExpressionBuilder().formatter(this),
         };
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/resources/org/gvsig/fmap/dal/store/h2/resultSetForSetProvider.sql
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/resources/org/gvsig/fmap/dal/store/h2/resultSetForSetProvider.sql	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/resources/org/gvsig/fmap/dal/store/h2/resultSetForSetProvider.sql	(revision 46050)
@@ -57,3 +57,54 @@
     "Bool2", "String", "Bool3", "Double", "Bool4", "Float", "Bool5", "Decimal", 
     NVL2("Geometry",ST_AsBinary("Geometry"),NULL), "ID" 
   FROM "PUBLIC"."test" ORDER BY "ID" ASC;
+
+-- Computed Attribute
+SELECT "ID", "Byte", "Bool1", "Long", "Timestamp", "Date", "Time", 
+    "Bool2", "String", "Bool3", "Double", "Bool4", "Float", "Bool5", "Decimal", 
+    NVL2("Geometry",ST_AsBinary("Geometry"),NULL), 
+    ("ID" * 2) AS "Compu1" 
+FROM "PUBLIC"."test" ORDER BY "ID" ASC;
+
+-- Computed Attribute 2
+SELECT "ID", "Byte", "Bool1", "Long", "Timestamp", "Date", "Time", 
+    "Bool2", "String", "Bool3", "Double", "Bool4", "Float", "Bool5", "Decimal", 
+    NVL2("Geometry",ST_AsBinary("Geometry"),NULL), 
+    ("ID" * 2) AS "Compu1", 
+    (("Long" + 10) + (("ID" * 2))) AS "Compu2" 
+FROM "PUBLIC"."test" ORDER BY "ID" ASC;
+
+-- Computed Extra column 1
+SELECT "ID", "Byte", "Bool1", "Long", "Timestamp", "Date", "Time", 
+    "Bool2", "String", "Bool3", "Double", "Bool4", "Float", "Bool5", "Decimal", 
+    NVL2("Geometry",ST_AsBinary("Geometry"),NULL), 
+    ("ID" * 2) AS "Compu1", 
+    (("Long" + 10) + (("ID" * 2))) AS "Extra1" 
+FROM "PUBLIC"."test" ORDER BY "ID" ASC;
+
+-- Computed Extra column 2
+SELECT "ID", "Byte", "Bool1", "Long", "Timestamp", "Date", "Time", 
+    "Bool2", "String", "Bool3", "Double", "Bool4", "Float", "Bool5", "Decimal", 
+    NVL2("Geometry",ST_AsBinary("Geometry"),NULL), 
+    ("ID" * 2) AS "Extra1", 
+    (("Long" + 10) + (("ID" * 2))) AS "Extra2" 
+FROM "PUBLIC"."test" ORDER BY "ID" ASC;
+
+-- Computed Extra column with where
+SELECT "ID", "Byte", "Bool1", "Long", "Timestamp", "Date", "Time", 
+    "Bool2", "String", "Bool3", "Double", "Bool4", "Float", "Bool5", "Decimal", 
+    NVL2("Geometry",ST_AsBinary("Geometry"),NULL), 
+    ("ID" * 2) AS "Compu1", 
+    (("Long" + 10) + (("ID" * 2))) AS "Extra1" 
+FROM "PUBLIC"."test" WHERE (((("Long" + 10) + (("ID" * 2)))) > 10) ORDER BY ((("Long" + 10) + (("ID" * 2)))) ASC, "ID" ASC;
+
+-- Group by with computed columns and aggregate functions
+SELECT MIN("test"."ID") AS "ID", MAX("test"."Byte") AS "Byte", NULL AS "Bool1", "Long", 
+    NULL AS "Timestamp", NULL AS "Date", NULL AS "Time", NULL AS "Bool2", 
+    NULL AS "String", NULL AS "Bool3", SUM("test"."Double") AS "Double", 
+    NULL AS "Bool4", NULL AS "Float", NULL AS "Bool5", NULL AS "Decimal", 
+    NULL AS "Geometry", 
+    ("ID" * 2) AS "Compu1", 
+    SUM(("Long" + 300)) AS "Compu2", 
+    SUM(((20 + "Byte") + (("ID" * 2)))) AS "Extra2", 
+    (("Long" + 10) + (("ID" * 2))) AS "Extra1" 
+FROM "PUBLIC"."test" GROUP BY "test"."Long", "Extra1", "Compu1" ORDER BY "ID" ASC;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/java/org/gvsig/fmap/dal/store/h2/TestUtils.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/java/org/gvsig/fmap/dal/store/h2/TestUtils.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/java/org/gvsig/fmap/dal/store/h2/TestUtils.java	(revision 46050)
@@ -94,6 +94,18 @@
         );
         return store;
     }
+    
+    public static FeatureStore openSourceStore2() throws Exception {
+        DataManager dataManager = DALLocator.getDataManager();
+        File f = getResourceAsFile("/org/gvsig/fmap/dal/store/h2/testCreateSource2.csv");
+        FeatureStore store = (FeatureStore) dataManager.openStore(
+                DataStore.CSV_PROVIDER_NAME, 
+                "file=",f,
+                "automaticTypesDetection=", false,
+                "locale=","en"
+        );
+        return store;
+    }
  
 
     public static List<String> getSQLs(String name) throws Exception {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/java/org/gvsig/fmap/dal/store/h2/TestCreate.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/java/org/gvsig/fmap/dal/store/h2/TestCreate.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/java/org/gvsig/fmap/dal/store/h2/TestCreate.java	(revision 46050)
@@ -1,5 +1,6 @@
 package org.gvsig.fmap.dal.store.h2;
 
+import java.util.ArrayList;
 import java.util.Date;
 import java.util.List;
 import junit.framework.TestCase;
@@ -12,6 +13,7 @@
 import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.exception.ValidateDataParametersException;
 import org.gvsig.fmap.dal.feature.EditableFeature;
+import org.gvsig.fmap.dal.feature.EditableFeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.EditableFeatureType;
 import org.gvsig.fmap.dal.feature.Feature;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
@@ -19,8 +21,10 @@
 import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.dal.feature.FeatureType;
 import org.gvsig.fmap.dal.feature.NewFeatureStoreParameters;
+import org.gvsig.fmap.dal.impl.expressionevaluator.DefaultFeatureAttributeEmulatorExpression;
 import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCServerExplorer;
+import org.gvsig.tools.dispose.DisposeUtils;
 import org.gvsig.tools.library.impl.DefaultLibrariesInitializer;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
@@ -307,5 +311,108 @@
         List<Feature> features = h2Store.getFeatures(query);
         int sz = features.size();
     }
+    
+    public void testComputed1() throws Exception {
+        FeatureStore sourceStore = TestUtils.openSourceStore1();
+        JDBCServerExplorer explorer = TestUtils.openServerExplorer(DBNAME);
+        
+        createFrom(explorer, sourceStore);        
+        copyFrom(explorer, sourceStore, FeatureStore.MODE_APPEND);
+      
+        FeatureStore h2Store = openTargetStore1(explorer);
+        h2Store.edit();
+        FeatureType featureType = h2Store.getDefaultFeatureType();
+        EditableFeatureType eFeatureType = featureType.getEditable();
+        eFeatureType.add("Compu1", DataTypes.INTEGER, new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("ID*2")));
+        eFeatureType.add("Compu2", DataTypes.INTEGER, new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("Long+10+Compu1")));
+        h2Store.update(eFeatureType);
+        h2Store.finishEditing();
+        List<Feature> features = h2Store.getFeatures();
+        for (int i = 0; i < features.size(); i++) {
+            Feature feature = features.get(i);
+            assertEquals("Compu1 "+i, feature.getInt("ID") * 2, feature.getInt("Compu1"));
+            if(feature.get("Long")==null) {
+                assertEquals("Compu2 "+i, null, feature.get("Compu2"));
+            } else {
+                assertEquals("Compu2 "+i, feature.getInt("Long") + 10 + feature.getInt("Compu1"), feature.getInt("Compu2"));
+            }
+        }
+        DisposeUtils.dispose(h2Store);
+    }
+    
+    public void testComputed2() throws Exception {
+        FeatureStore sourceStore = TestUtils.openSourceStore1();
+        JDBCServerExplorer explorer = TestUtils.openServerExplorer(DBNAME);
+        
+        createFrom(explorer, sourceStore);        
+        copyFrom(explorer, sourceStore, FeatureStore.MODE_APPEND);
+      
+        FeatureStore h2Store = openTargetStore1(explorer);
+        h2Store.edit();
+        FeatureType featureType = h2Store.getDefaultFeatureType();
+        EditableFeatureType eFeatureType = featureType.getEditable();
+        FeatureQuery query = sourceStore.createFeatureQuery();
+        eFeatureType.add("Compu1", DataTypes.INTEGER, new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("MOD(ID,10)")));
+        eFeatureType.add("Compu2", DataTypes.INTEGER, new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("Long+300")));
+        EditableFeatureAttributeDescriptor extraColumn1 = query.getExtraColumn().add("Extra1", DataTypes.INTEGER);
+        EditableFeatureAttributeDescriptor extraColumn2 = query.getExtraColumn().add("Extra2", DataTypes.INTEGER);
+//        EditableFeatureAttributeDescriptor extraColumn3 = query.getExtraColumn().add("LongMax", DataTypes.INTEGER);
+        extraColumn1.setFeatureAttributeEmulator(new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("Compu1+1")));
+        extraColumn2.setFeatureAttributeEmulator(new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("20+Byte")));
+//        extraColumn3.setFeatureAttributeEmulator(new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("Long")));
+        query.getGroupByColumns().add("Decimal");
+        query.getGroupByColumns().add("Extra1");
+//        query.getGroupByColumns().add("Compu1");
+        query.getAggregateFunctions().put("ID", "MIN");
+        query.getAggregateFunctions().put("Byte", "MIN");
+//        query.getAggregateFunctions().put("Long", "MIN");
+//        query.getAggregateFunctions().put("LongMax", "MAX");
+        query.getAggregateFunctions().put("Compu1", "MIN");
+        query.getAggregateFunctions().put("Double", "SUM");
+        query.getAggregateFunctions().put("Extra2", "SUM");
+        query.getAggregateFunctions().put("Compu2", "SUM");
+        h2Store.update(eFeatureType);
+        h2Store.finishEditing();
+        
+        
+        List<Feature> features0 = h2Store.getFeatures(query);
+        ArrayList<Feature> features = new ArrayList<>();
+        
+        for (int i = 0; i < features0.size(); i++) {
+            Feature feature = features0.get(i);
+            features.add(feature.getCopy());
+        }
+        features0 = null;
+        features.get(1).get("Compu1");
+        features.get(1).get("Compu2");
+//        assertEquals("Long0",null,features.get(0).get("Long"));
+//        assertEquals("Long1",null,features.get(1).get("Long"));
+//        assertEquals("Long2",1000L,features.get(2).getLong("Long"));
+//        assertEquals("Long3",1001L,features.get(3).getLong("Long"));
+//        assertEquals("Long4",2000L,features.get(4).getLong("Long"));
+//        assertEquals("Long5",2002L,features.get(5).getLong("Long"));
+//        assertEquals("Long6",3000L,features.get(6).getLong("Long"));
+//        assertEquals("Long7",4000L,features.get(7).getLong("Long"));
+//        assertEquals("Long8",4001L,features.get(8).getLong("Long"));
+//        assertEquals("Long9",5000L,features.get(9).getLong("Long"));
+//        assertEquals("Long10",5002L,features.get(10).getLong("Long"));
+//        assertEquals("Long11",6000L,features.get(11).getLong("Long"));
+//        assertEquals("Long12",6003L,features.get(12).getLong("Long"));
+//        assertEquals("Long13",7000L,features.get(13).getLong("Long"));
+//        assertEquals("Long14",7004L,features.get(14).getLong("Long"));
+//        assertEquals("Long15",8000L,features.get(15).getLong("Long"));
+//        assertEquals("Long16",8005L,features.get(16).getLong("Long"));
+//        assertEquals("Long17",9000L,features.get(17).getLong("Long"));
+//        assertEquals("Long18",9006L,features.get(18).getLong("Long"));
+        
+//        for (int i = 0; i < features.size(); i++) {
+//            Feature feature = features.get(i);
+//            assertEquals("Long", feature.getInt("ID") * 2, feature.getInt("Compu1"));
+//            assertEquals("Compu2", feature.getInt("Long") + 10 + feature.getInt("Compu1"), feature.getInt("Compu2"));
+//        }
+        DisposeUtils.dispose(h2Store);
+    }
+    
+    
 
 }
